<?php

/**
 * Albireo Kernel
 *
 * @copyright  Copyright (c) 2012 Celebrio Software, s.r.o.
 * @package    Kernel
 */
namespace Celebrio\Caching;

use \Nette\Caching\Cache;
use \Nette\Object;
use \Nette\Environment;
use Celebrio\Caching\WinCacheStorage;
use Celebrio\Caching\APCStorage;

/**
 * @author Pavel and Martin Novák
 */

abstract class CacheName extends Object {

    /**
     * Getting the class name (with namespace) where all namespace dividers
     * (backslash signs) are replaced by dots (java ftw). It might be used
     * for example when creating Nette\Cache namespace.
     * supports WinCache, APC and Nette file cache
     *
     * The storage for the cache is loaded dynamically from Environment settings.
     * It is initialized by CacheFactory class according to the available services
     * (in-memory storage is preferred).
     *
     * @return Nette\Caching\Cache cache identified by dot-separated class namespace + name
     */
    public static function generate(Object $clazz) {
        $className = $clazz::getReflection()->name;
        return Environment::getCache(\str_replace("\\", ".", $className));
    }
    
}