<?php
/**
 * Celebrio Core
 * 
 * @copyright  Copyright (c) 2011 Celebrio Software
 * @package    Celebrio
 * @subpackage Core
 */
namespace Celebrio\Core;

use \Exception;
use \InvalidArgumentException;
use \RuntimeException;

/** Module dependency problem. */
class DependencyException extends Exception { }

/** Error when working with configuration. */
class ConfigException extends Exception { }

/** Manifest contains errors. */
class ManifestException extends RuntimeException { }

/** Class/Interface specified in manifest cannot be found. */
class ClassNotFoundException extends ManifestException { }

/** There was a reason to switch to the critical mode */
class CriticalException extends Exception { }

/** The requested service cannot be found, i.e it's not installed */
class NoSuchServiceException extends Exception { }

/** Error when installation module. */
class ModuleInstallationException extends Exception { }