CREATE TABLE [logins]
(
 [user_id] Int NOT NULL,
 [time] Datetime2 DEFAULT CURRENT_TIMESTAMP NOT NULL,
 [ip] Char(39) NOT NULL,
 [host] nvarchar(255) NOT NULL,
 [agent] nvarchar(255) NOT NULL
);
CREATE INDEX [logins users] ON [logins] ([user_id]);
ALTER TABLE [logins] ADD CONSTRAINT [PK_logins] PRIMARY KEY ([user_id],[time]);

CREATE TABLE [passwords]
(
 [user_id] Int NOT NULL,
 [password] Char(128) NOT NULL,
 [created] Datetime2 DEFAULT CURRENT_TIMESTAMP NOT NULL
);
CREATE INDEX [passwords users] ON [passwords] ([user_id]);
ALTER TABLE [passwords] ADD CONSTRAINT [PK_passwords] PRIMARY KEY ([user_id],[created]);


CREATE TABLE [security_questions]
(
 [user_id] Int NOT NULL,
 [question] nvarchar(255) NOT NULL,
 [answer] nvarchar(255) NOT NULL
);
CREATE INDEX [security question user] ON [security_questions] ([user_id]);
ALTER TABLE [security_questions] ADD CONSTRAINT [PK_security_questions] PRIMARY KEY ([user_id]);

CREATE TABLE [users]
(
 [id] Int IDENTITY(1,1) NOT NULL,
 [id_person] Int NULL,
 [user_name] nvarchar(45) NOT NULL UNIQUE,
 [first_name] nvarchar(45) NULL,
 [last_name] nvarchar(45) NULL,
 [created] Datetime2 DEFAULT CURRENT_TIMESTAMP NOT NULL,
 [status] nvarchar(10) NOT NULL,
 [expiration] Datetime2 NULL,
 [language] Char(5) NOT NULL,
 [time_zone] nvarchar(45) NOT NULL
);
ALTER TABLE [users] ADD CONSTRAINT [PK_users] PRIMARY KEY ([id]);
--ALTER TABLE [users] ADD CONSTRAINT [user_name] UNIQUE ([user_name]);

CREATE TABLE [guest_log]
(
 [guest_count] Int NOT NULL PRIMARY KEY,
);

ALTER TABLE [logins] ADD CONSTRAINT [logins users] FOREIGN KEY ([user_id]) REFERENCES [users] ([id]) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE [passwords] ADD CONSTRAINT [passwords users] FOREIGN KEY ([user_id]) REFERENCES [users] ([id]) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE [security_questions] ADD CONSTRAINT [security question user] FOREIGN KEY ([user_id]) REFERENCES [users] ([id]) ON UPDATE CASCADE ON DELETE CASCADE;