<?php

/**
 * Albireo Kernel
 *
 * @copyright  Copyright (c) 2010 Albireo Solutions
 * @package    Kernel
 */

namespace Albireo\Forms;

use Nette;


/**
 * Albireo Form Renderer
 *
 * @author     Albireo Solutions
 * @package    Kernel
 */
class AlbireoFormRenderer extends Nette\Forms\ConventionalRenderer
{
    public $wrappers = array(
		'form' => array(
			'container' => NULL,
			'errors' => TRUE,
		),

		'error' => array(
			'container' => 'ul class=error',
			'item' => 'li',
		),

		'group' => array(
			'container' => 'fieldset',
			'label' => 'legend',
			'description' => 'p',
		),

		'controls' => array(
			'container' => NULL,
		),

		'pair' => array(
			'container' => 'div',
			'.required' => 'required',
			'.optional' => NULL,
			'.odd' => NULL,
		),

		'control' => array(
			'container' => NULL,
			'.odd' => NULL,

			'errors' => FALSE,
			'description' => 'small',
			'requiredsuffix' => '',

			'.required' => 'required',
			'.text' => 'textInput',
			'.password' => 'textInput',
			'.file' => 'textInput',
			'.submit' => 'ui-button ui-button-text-only ui-widget ui-state-default ui-corner-all',
			'.image' => 'imagebutton',
			'.button' => 'ui-button ui-button-text-only ui-widget ui-state-default ui-corner-all',
		),

		'label' => array(
			'container' => NULL,
			'suffix' => NULL,
			'requiredsuffix' => '',
		),

		'hidden' => array(
			'container' => NULL,
		),
	);
}